##
##  nim.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2021 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         nim
Summary:      NIM Programming Language
URL:          https://nim-lang.org/
Vendor:       Andreas Rumpf
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Language
License:      MIT
Version:      1.6.0
Release:      20211022

#   list of sources
Source0:      https://nim-lang.org/download/nim-%{version}.tar.xz
Patch0:       nim.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Nim is a systems and applications programming language. Statically
    typed and compiled, it provides unparalleled performance in an
    elegant package. High-performance garbage-collected language,
    compiles to C, C++ or JavaScript and produces dependency-free
    binaries.

%track
    prog nim = {
        version   = %{version}
        url       = https://github.com/nim-lang/Nim/releases
        regex     = v(__VER__)\.tar\.gz
    }

%prep
    %setup -q
    %patch -p0

%build
    export CC="%{l_cc}"
    export CFLAGS="%{l_cflags -O}"
    export CPPFLAGS="%{l_cppflags}"
    export LDFLAGS="%{l_ldflags}"
    export HOME=`pwd`
    sh build.sh
    ./bin/nim c koch
    ./koch boot -d:release
    ./koch tools

%install
    export HOME=`pwd`
    sh install.sh $RPM_BUILD_ROOT%{l_prefix}/libexec
    strip $RPM_BUILD_ROOT%{l_prefix}/libexec/nim/bin/* >/dev/null 2>&1 || true
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    (   echo "#!/bin/sh"
        echo "exec %{l_prefix}/libexec/nim/bin/nim \${1+\"\$@\"}"
    ) >nim.sh
    %{l_shtool} install -c -m 755 \
        nim.sh $RPM_BUILD_ROOT%{l_prefix}/bin/nim
    %{l_shtool} install -c -s -m 755 \
        koch bin/nimsuggest bin/nimble bin/nimgrep \
        $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

